<template>
  <div v-if="isShow">
    <ElUiDialog
      ref="modal"
      class="ob-modal-container"
      :class="[ isReadOnly && 'obForm-disabled' ]"
      :visible.sync="visible"
      :custom-class="modalClass"
      :append-to-body="isModalAppendToBody"
      :show-close="false"
      :modal-append-to-body="isModalAppendToBody"
      :close-on-click-modal="isCloseOnOverlay"
      :close-on-press-escape="isCloseOnOverlay"
      :is-confirm="isConfirm"
      :data-qa="dataQa"
      :str-confirm-modal-title="strConfirmModalTitle"
      :str-confirm-modal-text="strConfirmModalText"
      :str-confirm-modal-ok-button="strConfirmModalOkButton"
      :str-confirm-modal-cancel-button="strConfirmModalCancelButton"
      :has-active-child="hasActiveChild"
      @close="$emit('close')"
    >
      <div
        slot="title"
        class="modal-header"
      >
        <template v-if="$slots.title">
          <slot name="title" />
        </template>
        <template v-else>
          <div class="title">
            <div
              v-if="titleSecond"
              class="title__second"
            >
              {{ titleSecond }}
            </div>
            <div class="ob-ty-modal-title">
              <button
                v-if="isShowBackButton"
                class="arrow back"
                :data-qa="dataQa + '_btnArrowBack'"
                @click="back"
              >
                <i class="icon chevron-left" />
              </button>

              {{ title }}
            </div>
          </div>
        </template>
        <div
          v-if="isShowPagination"
          class="actions"
        >
          <button
            v-if="isArrowPrev"
            class="arrow"
            :data-qa="dataQa + '_btnArrowPrev'"
            @click="navigation(false)"
          >
            <i class="icon chevron-up" />
          </button>
          <button
            v-if="isArrowNext"
            class="arrow"
            :data-qa="dataQa + '_btnArrowNext'"
            @click="navigation(true)"
          >
            <i class="icon chevron-down" />
          </button>
        </div>
        <div
          v-if="isShowCloseButton && !isShowPagination"
          class="action-close"
        >
          <i
            class="icon close"
            :data-qa="dataQa + '_close'"
            @click="cancel"
          />
        </div>
      </div>
      <div
        :data-qa="dataQa"
        class="modal-body"
      >
        <slot name="default" />
      </div>
      <div
        v-show="isShowControls"
        class="modal-footer"
      >
        <ObFormControls
          :dropdown-menu="dropdownMenu"
          :is-submit-disabled="isSubmitDisabled"
          :ok-text="okText"
          :cancel-text="cancelText"
          :is-read-only="isReadOnly"
          :is-only-submit="isOnlySubmit"
          :is-watch-form="false"
          :is-error="isError"
          :is-active-element="isActiveElement"
          :btn-modal="btnModal"
          :data-qa="dataQa"
          @submit="$emit('submit', $event)"
          @cancel="cancel"
          @on-change-active="$emit('change-active', $event)"
          @on-btn-modal="$emit('on-btn-modal')"
        />
      </div>
      <slot name="footer" />
    </ElUiDialog>
  </div>
</template>
<script>
import ObFormControls from '../obForm/ObFormControls'
import ElUiDialog from './ElUiDialog'

export default {
  name: 'ObModal',
  components: {
    ObFormControls,
    ElUiDialog
  },
  props: {
    isCloseOnOverlay: {
      type: Boolean,
      default: true
    },
    isConfirm: {
      type: Boolean,
      default: false
    },
    indexActiveInitial: Number,
    isOnlyClose: {
      type: Boolean,
      default: false
    },
    isShowPagination: {
      type: Boolean,
      default: false
    },
    isShowBackButton: {
      type: Boolean,
      default: false
    },
    isShowCloseButton: {
      type: Boolean,
      default: false
    },
    title: String,
    titleSecond: {
      type: String,
      default: null
    },
    customClass: {
      type: String,
      default: ''
    },
    size: {
      type: String,
      default: 'small'
    },
    isNested: {
      type: Boolean,
      default: false
    },
    isModalAppendToBody: {
      type: Boolean,
      default: true
    },
    dropdownMenu: {
      type: Array,
      default: () => []
    },
    okText: {
      type: String,
      default: 'Сохранить'
    },
    cancelText: {
      type: String,
      default: 'Отмена'
    },
    isSubmitDisabled: {
      type: Boolean,
      default: false
    },
    isShowControls: {
      type: Boolean,
      default: false
    },
    dataGrid: {
      type: Object,
      default: null
    },
    isReadOnly: {
      type: Boolean,
      default: false
    },
    isOnlySubmit: {
      type: Boolean,
      default: false
    },
    isCenter: {
      type: Boolean,
      default: false
    },
    isError: {
      type: Boolean,
      default: false
    },
    isActiveElement: {
      type: Boolean,
      default: null
    },
    btnModal: {
      type: String,
      default: null
    },
    dataQa: {
      type: String
    },
    strConfirmModalTitle: {
      type: String,
      default: null
    },
    strConfirmModalText: {
      type: String,
      default: null
    },
    strConfirmModalOkButton: {
      type: String,
      default: null
    },
    strConfirmModalCancelButton: {
      type: String,
      default: null
    }
  },
  data () {
    return {
      isShow: true,
      isActive: true,
      visible: false,
      isArrowNext: true,
      isArrowPrev: true,
      hasActiveChild: false
    }
  },
  computed: {
    sizeClass () {
      return `modal-${this.size}`
    },
    typeClass () {
      return `modal--${this.isError ? 'error' : 'primary'}`
    },
    isNotContent () {
      return Boolean(!Object.keys(this.$slots).length) && Boolean(!Object.keys(this.$scopedSlots).length)
    },
    modalClass () {
      return [
        'modal',
        'ob-modal',
        this.isCenter && '--is-center',
        this.isNotContent && '--is-not-content',
        this.customClass,
        this.sizeClass,
        this.typeClass
      ].join(' ')
    }
  },
  watch: {
    visible (val) {
      if (!val) {
        this.$emit('closed')
      } else {
        this.$emit('opened')
      }
    }
  },
  beforeCreate () {
    document.getElementsByTagName('body')[0].addEventListener('keyup', (e) => {
      if (this.isShowPagination) {
        if (e.keyCode === 38) this.navigation(false)
        if (e.keyCode === 40) this.navigation(true)
      }
    })
    this.$eventGlobal.$on('hideArrowNext', () => {
      this.hideArrow('next')
    })
    this.$eventGlobal.$on('hideArrowPrev', () => {
      this.hideArrow('prev')
    })
    this.$eventGlobal.$on('showArrowNext', () => {
      this.showArrow('next')
    })
    this.$eventGlobal.$on('showArrowPrev', () => {
      this.showArrow('prev')
    })
    this.$eventGlobal.$on('prevent-modal-close', (val) => {
      this.hasActiveChild = val
    })
  },
  methods: {
    hideArrow (type) {
      if (type === 'next') this.isArrowNext = false
      if (type === 'prev') this.isArrowPrev = false
    },
    showArrow (type) {
      if (type === 'next') this.isArrowNext = true
      if (type === 'prev') this.isArrowPrev = true
    },
    submit () {
      this.$emit('submit')
      this.close()
    },
    back () {
      this.$emit('back')
    },
    cancel () {
      if (!this.isConfirm) {
        this.$refs.modal.handleBeforeClose()
      } else {
        this.$emit('cancel')
        this.close()
      }
    },
    open () {
      if (!this.isShow) {
        this.isShow = true
      }
      if (!this.visible) {
        setTimeout(() => {
          document.body.classList.add('el-popup-parent--hidden')
        }, 0)
        this.visible = true
      }
    },
    close () {
      if (this.visible) {
        this.visible = false
      }
    },
    show () {
      this.isShow = true
      this.open()
    },
    hide () {
      this.isShow = false
      this.close()
    },
    navigation (nextMode) {
      if (nextMode) {
        this.$eventGlobal.$emit('tableNextRow')
        this.$emit('tableNextRow')
      } else {
        this.$eventGlobal.$emit('tablePrevRow')
        this.$emit('tablePrevRow')
      }
    }
  }
}
</script>
<style lang="scss">
@import "../../static/css/mixins";
@import "../../static/css/variables";
.ob-modal-container {
  display: flex;
  flex-direction: column;
  justify-content: flex-start;
  .el-dialog {
    margin: 80px auto 20px auto !important;
  }
  .el-dialog__header, .el-dialog__body, .el-dialog__footer {
    padding: 0 !important;
  }
  .ob-ty-modal-title {
    font-family: Roboto, sans-serif;
    font-style: normal;
    font-weight: normal;
    font-size: 28px;
    line-height: 32px;
    color: $color-text-base;
  }
  .modal {
    max-width: calc(100% - 40px) !important;
    transition: width .1s ease;
    &-small, &-sm {
      width: 440px !important;
    }
    &-medium, &-md {
      width: 660px !important;
    }
    &-large, &-bg {
      width: 880px !important;
    }
    &-extra-large, &-xl {
      width: 1100px !important;
    }
    &-double-medium, &-double-md {
      width: 1320px !important;
    }
    &-max {
      width: calc(100% - 40px) !important;
    }
    &--hide-footer {
      .el-dialog__footer {
        display: none;
      }
    }
    &-footer {
      display: flex;
      justify-content: flex-end;
      align-items: center;
    }
  }
  .modal {
    border-radius: 3px;
    padding: 40px;
    &-header {
      display: flex;
      justify-content: space-between;
      align-items: center;
      margin-bottom: 24px;
      .title {
        position: relative;
        display: flex;
        flex-direction: column;
        width: calc(100% - 10px);
        .icon {
          font-size: 24px;
          line-height: 24px;
        }
        &__second {
          position: absolute;
          max-width: 100%;
          overflow: hidden;
          height: 12px;
          left: 1px;
          top: -15px;
          text-overflow: ellipsis;
          @include font-mixin(10px, 12px, 400, $color-grey-span, 0.4px, uppercase);
        }
      }
      .action-close {
        position: absolute;
        top: 25px;
        right: 25px;
        width: 14px;
        height: 14px;
        i {
          display: block;
          cursor: pointer;
          font-size: 14px;
          color: $color-blue-navy-blue;
        }
      }
      .actions {
        display: flex;
        align-items: flex-start;
        flex-wrap: nowrap;
        align-self: flex-start;
        transform: translateY(-1px);
      }
      .arrow {
        display: inline-block;
        width: 24px;
        height: 24px;
        border: 0;
        background-color: transparent;
        padding: 0;
        outline: none;
        cursor: pointer;
        i {
          display: inline-flex;
          font-size: 24px;
          color: $color-blue-navy-blue;
        }
        &:active {
          background-color: $light-lavender;
        }
        &.back {
          margin-right: 4px;
          position: relative;
          top: 1px;
        }
      }
      .arrow + .arrow {
        margin-left: 10px;
      }
      &__icon-error {
        margin-right: 10px;
        color: $color-error;
        &::before {
          color: $color-error !important;
        }
      }
    }
    &-footer {
      margin-top: 40px;
    }
    &-body {
      .row{
        margin-top: 15px;
        margin-bottom: 15px;
      }
      .ob-tabs__content > div {
        & > label {
          margin-bottom: 5px;
          float: left;
          width: 100%;
        }

        & > .ob-selector {
          margin-top: 15px;
        }
      }
      p + p {
        margin-top: 30px;
      }
      p {
        @include font-mixin(14px, 18px, 400, $obModal-body_color);
        word-break: break-word;
      }
    }
    &.--is-not-content {
      .modal-header {
        margin-bottom: 0;
      }
    }
    &.--is-center {
      margin: auto !important;
    }
    &--error {
      padding-top: 40px !important;
      &:before {
        content: '';
        position: absolute;
        top: 0;
        left: 0;
        display: block;
        width: 100%;
        height: 10px;
        background-color: $color-error;
        border-radius: 3px 3px 0 0;
      }
      .title, .ob-ty-modal-title {
        color: $color-error !important;
      }
    }
  }
}
</style>
